<script setup>
//librerías
import { ref } from 'vue'
import BlogPost from "./components/BlogPost.vue"
import PaginatePost from "./components/PaginatePost.vue"
import LoadingSpinner from "./components/LoadingSpinner.vue"

//constantes
const favorito = ref("")
const posts = ref([])
const postXPage = 5
const inicio = ref(0)
const fin = ref(postXPage)
const loading = ref(true)

//funciones
const cambiarFavorito = title => favorito.value = title
const next = () => {
  inicio.value = inicio.value + postXPage;
  fin.value = fin.value + postXPage
}
const preview = () => {
  inicio.value = inicio.value - postXPage;
  fin.value = fin.value - postXPage
}

//base de datos
const fetchData = async() => {
  try {
    const res = await fetch("https://jsonplaceholder.typicode.com/posts")
    posts.value = await res.json()
  } catch(error){
    console.log(error)
  } finally {
    loading.value = false
  }
}

fetchData()

</script>

<template>
  <LoadingSpinner v-if="loading" />
  <div v-else class="container">
    <h1>APP</h1>
    <h2>Mis Post Favorito: {{ favorito }}</h2>
    <PaginatePost 
      @next="next"
      @preview="preview" 
      :inicio="inicio"
      :fin="fin"
      :maxLength="posts.length"
      class="mb-2"
    />
      <BlogPost 
        v-for="post in posts.slice(inicio, fin)" 
        :key="post.id"
        :title=post.title 
        :id=post.id 
        :body=post.body
        @cambiarFavorito="cambiarFavorito"
        class="mb-2"
      />
  </div>
</template>